target datalayout = "e-p:64:64:64-i1:8:8-i8:8:8-i16:16:16-i32:32:32-i64:64:64-f32:32:32-f64:64:64-v16:16:16-v24:32:32-v32:32:32-v48:64:64-v64:64:64-v96:128:128-v128:128:128-v192:256:256-v256:256:256-v512:512:512-v1024:1024:1024"
target triple = "spir64-unknown-unknown"

%struct.structArg = type { i32, float }

; Function Attrs: nounwind
define spir_kernel void @clone_kernel_test0(i32 %iarg, float %farg, %struct.structArg* byval %sarg, i32 addrspace(3)* %localbuf, i32 addrspace(1)* %outbuf) #0 {
entry:
  %0 = call spir_func <3 x i64> @BuiltInGlobalInvocationId() #1
  %call = extractelement <3 x i64> %0, i32 0
  %conv = trunc i64 %call to i32
  %arrayidx = getelementptr inbounds i32, i32 addrspace(1)* %outbuf, i64 0
  store i32 %iarg, i32 addrspace(1)* %arrayidx, align 4
  %i = getelementptr inbounds %struct.structArg, %struct.structArg* %sarg, i32 0, i32 0
  %1 = load i32, i32* %i, align 4
  %arrayidx1 = getelementptr inbounds i32, i32 addrspace(1)* %outbuf, i64 1
  store i32 %1, i32 addrspace(1)* %arrayidx1, align 4
  %2 = bitcast i32 addrspace(1)* %outbuf to float addrspace(1)*
  %arrayidx2 = getelementptr inbounds float, float addrspace(1)* %2, i64 2
  store float %farg, float addrspace(1)* %arrayidx2, align 4
  %f = getelementptr inbounds %struct.structArg, %struct.structArg* %sarg, i32 0, i32 1
  %3 = load float, float* %f, align 4
  %4 = bitcast i32 addrspace(1)* %outbuf to float addrspace(1)*
  %arrayidx3 = getelementptr inbounds float, float addrspace(1)* %4, i64 3
  store float %3, float addrspace(1)* %arrayidx3, align 4
  ret void
}

; Function Attrs: nounwind
define spir_kernel void @buf_read_kernel(i32 addrspace(1)* %buf, i32 addrspace(1)* %outbuf) #0 {
entry:
  %arrayidx = getelementptr inbounds i32, i32 addrspace(1)* %buf, i64 0
  %0 = load i32, i32 addrspace(1)* %arrayidx, align 4
  %arrayidx1 = getelementptr inbounds i32, i32 addrspace(1)* %outbuf, i64 6
  store i32 %0, i32 addrspace(1)* %arrayidx1, align 4
  ret void
}

; Function Attrs: nounwind
define spir_kernel void @buf_write_kernel(i32 addrspace(1)* %buf, i32 %write_val) #0 {
entry:
  %arrayidx = getelementptr inbounds i32, i32 addrspace(1)* %buf, i64 0
  store i32 %write_val, i32 addrspace(1)* %arrayidx, align 4
  ret void
}

; Function Attrs: nounwind readnone
declare spir_func <3 x i64> @BuiltInGlobalInvocationId() #1

attributes #0 = { nounwind }
attributes #1 = { nounwind readnone }

!opencl.kernels = !{!0, !7, !14}
!IGCMetadata = !{!19}
!opencl.enable.FP_CONTRACT = !{}
!opencl.spir.version = !{!256}
!opencl.ocl.version = !{!256}
!opencl.used.extensions = !{!257}
!opencl.used.optional.core.features = !{!257}
!opencl.compiler.options = !{!258}

!0 = !{void (i32, float, %struct.structArg*, i32 addrspace(3)*, i32 addrspace(1)*)* @clone_kernel_test0, !1, !2, !3, !4, !5, !6}
!1 = !{!"kernel_arg_addr_space", i32 0, i32 0, i32 0, i32 3, i32 1}
!2 = !{!"kernel_arg_access_qual", !"none", !"none", !"none", !"none", !"none"}
!3 = !{!"kernel_arg_type", !"int", !"float", !"structArg", !"int*", !"int*"}
!4 = !{!"kernel_arg_type_qual", !"", !"", !"", !"", !""}
!5 = !{!"kernel_arg_base_type", !"int", !"float", !"struct structArg", !"int*", !"int*"}
!6 = !{!"kernel_arg_name", !"iarg", !"farg", !"sarg", !"localbuf", !"outbuf"}
!7 = !{void (i32 addrspace(1)*, i32 addrspace(1)*)* @buf_read_kernel, !8, !9, !10, !11, !12, !13}
!8 = !{!"kernel_arg_addr_space", i32 1, i32 1}
!9 = !{!"kernel_arg_access_qual", !"none", !"none"}
!10 = !{!"kernel_arg_type", !"int*", !"int*"}
!11 = !{!"kernel_arg_type_qual", !"", !""}
!12 = !{!"kernel_arg_base_type", !"int*", !"int*"}
!13 = !{!"kernel_arg_name", !"buf", !"outbuf"}
!14 = !{void (i32 addrspace(1)*, i32)* @buf_write_kernel, !15, !9, !16, !11, !17, !18}
!15 = !{!"kernel_arg_addr_space", i32 1, i32 0}
!16 = !{!"kernel_arg_type", !"int*", !"int"}
!17 = !{!"kernel_arg_base_type", !"int*", !"int"}
!18 = !{!"kernel_arg_name", !"buf", !"write_val"}
!19 = !{!"ModuleMD", !20, !21, !76, !137, !167, !183, !195, !205, !207, !208, !219, !220, !221, !222, !225, !226, !227, !228, !229, !230, !231, !232, !233, !234, !235, !236, !238, !242, !243, !244, !245, !246, !247, !120, !248, !249, !251, !254, !255}
!20 = !{!"isPrecise", i1 false}
!21 = !{!"compOpt", !22, !23, !24, !25, !26, !27, !28, !29, !30, !31, !32, !33, !34, !35, !36, !37, !38, !39, !40, !41, !42, !43, !44, !45, !46, !47, !48, !49, !50, !51, !52, !53, !54, !55, !56, !57, !58, !59, !60, !61, !62, !63, !64, !65, !66, !67, !68, !69, !70, !71, !72, !73, !74, !75}
!22 = !{!"DenormsAreZero", i1 false}
!23 = !{!"CorrectlyRoundedDivSqrt", i1 false}
!24 = !{!"OptDisable", i1 false}
!25 = !{!"MadEnable", i1 false}
!26 = !{!"NoSignedZeros", i1 false}
!27 = !{!"NoNaNs", i1 false}
!28 = !{!"FloatRoundingMode", i32 0}
!29 = !{!"FloatCvtIntRoundingMode", i32 3}
!30 = !{!"VISAPreSchedRPThreshold", i32 0}
!31 = !{!"SetLoopUnrollThreshold", i32 0}
!32 = !{!"UnsafeMathOptimizations", i1 false}
!33 = !{!"FiniteMathOnly", i1 false}
!34 = !{!"FastRelaxedMath", i1 false}
!35 = !{!"DashGSpecified", i1 false}
!36 = !{!"FastCompilation", i1 false}
!37 = !{!"UseScratchSpacePrivateMemory", i1 true}
!38 = !{!"RelaxedBuiltins", i1 false}
!39 = !{!"SubgroupIndependentForwardProgressRequired", i1 true}
!40 = !{!"GreaterThan2GBBufferRequired", i1 true}
!41 = !{!"GreaterThan4GBBufferRequired", i1 true}
!42 = !{!"DisableA64WA", i1 false}
!43 = !{!"ForceEnableA64WA", i1 false}
!44 = !{!"PushConstantsEnable", i1 true}
!45 = !{!"HasPositivePointerOffset", i1 false}
!46 = !{!"HasBufferOffsetArg", i1 false}
!47 = !{!"BufferOffsetArgOptional", i1 true}
!48 = !{!"HasSubDWAlignedPtrArg", i1 false}
!49 = !{!"replaceGlobalOffsetsByZero", i1 false}
!50 = !{!"forcePixelShaderSIMDMode", i32 0}
!51 = !{!"pixelShaderDoNotAbortOnSpill", i1 false}
!52 = !{!"UniformWGS", i1 false}
!53 = !{!"disableVertexComponentPacking", i1 false}
!54 = !{!"disablePartialVertexComponentPacking", i1 false}
!55 = !{!"PreferBindlessImages", i1 false}
!56 = !{!"UseBindlessMode", i1 false}
!57 = !{!"UseLegacyBindlessMode", i1 true}
!58 = !{!"disableMathRefactoring", i1 false}
!59 = !{!"atomicBranch", i1 false}
!60 = !{!"ForceMinSimdSizeForFastestCS", i1 false}
!61 = !{!"EnableFastestLinearScan", i1 false}
!62 = !{!"UseStatelessforPrivateMemory", i1 false}
!63 = !{!"EnableTakeGlobalAddress", i1 false}
!64 = !{!"IsLibraryCompilation", i1 false}
!65 = !{!"FastVISACompile", i1 false}
!66 = !{!"MatchSinCosPi", i1 false}
!67 = !{!"CaptureCompilerStats", i1 false}
!68 = !{!"EnableZEBinary", i1 false}
!69 = !{!"ExcludeIRFromZEBinary", i1 false}
!70 = !{!"allowDisableRematforCS", i1 false}
!71 = !{!"DisableIncSpillCostAllAddrTaken", i1 false}
!72 = !{!"DisableCPSOmaskWA", i1 false}
!73 = !{!"DisableFastestGopt", i1 false}
!74 = !{!"WaForceHalfPromotion", i1 false}
!75 = !{!"EnableUndefAlphaOutputAsRed", i1 true}
!76 = !{!"FuncMD", !77, !78, !133, !134, !135, !136}
!77 = !{!"FuncMDMap[0]", void (i32, float, %struct.structArg*, i32 addrspace(3)*, i32 addrspace(1)*)* @clone_kernel_test0}
!78 = !{!"FuncMDValue[0]", !79, !80, !84, !85, !86, !106, !112, !113, !114, !115, !116, !117, !118, !119, !120, !121, !122, !123, !124, !125, !126, !127, !128, !129, !130, !131, !132}
!79 = !{!"localOffsets"}
!80 = !{!"workGroupWalkOrder", !81, !82, !83}
!81 = !{!"dim0", i32 0}
!82 = !{!"dim1", i32 0}
!83 = !{!"dim2", i32 0}
!84 = !{!"funcArgs"}
!85 = !{!"functionType", !"KernelFunction"}
!86 = !{!"rtInfo", !87, !88, !89, !90, !91, !92, !93, !94, !95, !96, !97, !98, !99, !100, !101, !105}
!87 = !{!"callableShaderType", !"NumberOfCallableShaderTypes"}
!88 = !{!"isContinuation", i1 false}
!89 = !{!"hasTraceRayPayload", i1 false}
!90 = !{!"hasHitAttributes", i1 false}
!91 = !{!"hasCallableData", i1 false}
!92 = !{!"ShaderStackSize", i32 0}
!93 = !{!"ShaderHash", i64 0}
!94 = !{!"ShaderName", !""}
!95 = !{!"ParentName", !""}
!96 = !{!"SlotNum", i1* null}
!97 = !{!"NOSSize", i32 0}
!98 = !{!"Entries"}
!99 = !{!"SpillUnions"}
!100 = !{!"CustomHitAttrSizeInBytes", i32 0}
!101 = !{!"Types", !102, !103, !104}
!102 = !{!"FrameStartTys"}
!103 = !{!"ArgumentTys"}
!104 = !{!"FullFrameTys"}
!105 = !{!"Aliases"}
!106 = !{!"resAllocMD", !107, !108, !109, !110, !111}
!107 = !{!"uavsNumType", i32 0}
!108 = !{!"srvsNumType", i32 0}
!109 = !{!"samplersNumType", i32 0}
!110 = !{!"argAllocMDList"}
!111 = !{!"inlineSamplersMD"}
!112 = !{!"maxByteOffsets"}
!113 = !{!"IsInitializer", i1 false}
!114 = !{!"IsFinalizer", i1 false}
!115 = !{!"CompiledSubGroupsNumber", i32 0}
!116 = !{!"hasInlineVmeSamplers", i1 false}
!117 = !{!"localSize", i32 0}
!118 = !{!"localIDPresent", i1 false}
!119 = !{!"groupIDPresent", i1 false}
!120 = !{!"privateMemoryPerWI", i32 0}
!121 = !{!"globalIDPresent", i1 false}
!122 = !{!"hasSyncRTCalls", i1 false}
!123 = !{!"hasNonKernelArgLoad", i1 false}
!124 = !{!"hasNonKernelArgStore", i1 false}
!125 = !{!"hasNonKernelArgAtomic", i1 false}
!126 = !{!"UserAnnotations"}
!127 = !{!"m_OpenCLArgAddressSpaces"}
!128 = !{!"m_OpenCLArgAccessQualifiers"}
!129 = !{!"m_OpenCLArgTypes"}
!130 = !{!"m_OpenCLArgBaseTypes"}
!131 = !{!"m_OpenCLArgTypeQualifiers"}
!132 = !{!"m_OpenCLArgNames"}
!133 = !{!"FuncMDMap[1]", void (i32 addrspace(1)*, i32 addrspace(1)*)* @buf_read_kernel}
!134 = !{!"FuncMDValue[1]", !79, !80, !84, !85, !86, !106, !112, !113, !114, !115, !116, !117, !118, !119, !120, !121, !122, !123, !124, !125, !126, !127, !128, !129, !130, !131, !132}
!135 = !{!"FuncMDMap[2]", void (i32 addrspace(1)*, i32)* @buf_write_kernel}
!136 = !{!"FuncMDValue[2]", !79, !80, !84, !85, !86, !106, !112, !113, !114, !115, !116, !117, !118, !119, !120, !121, !122, !123, !124, !125, !126, !127, !128, !129, !130, !131, !132}
!137 = !{!"pushInfo", !138, !139, !140, !143, !144, !145, !146, !147, !148, !149, !150, !163, !164, !165, !166}
!138 = !{!"pushableAddresses"}
!139 = !{!"bindlessPushInfo"}
!140 = !{!"dynamicBufferInfo", !141, !142}
!141 = !{!"firstIndex", i32 0}
!142 = !{!"numOffsets", i32 0}
!143 = !{!"MaxNumberOfPushedBuffers", i32 0}
!144 = !{!"inlineConstantBufferSlot", i32 -1}
!145 = !{!"inlineConstantBufferOffset", i32 -1}
!146 = !{!"inlineConstantBufferGRFOffset", i32 -1}
!147 = !{!"constants"}
!148 = !{!"inputs"}
!149 = !{!"constantReg"}
!150 = !{!"simplePushInfoArr", !151, !160, !161, !162}
!151 = !{!"simplePushInfoArrVec[0]", !152, !153, !154, !155, !156, !157, !158, !159}
!152 = !{!"cbIdx", i32 0}
!153 = !{!"pushableAddressGrfOffset", i32 -1}
!154 = !{!"pushableOffsetGrfOffset", i32 -1}
!155 = !{!"offset", i32 0}
!156 = !{!"size", i32 0}
!157 = !{!"isStateless", i1 false}
!158 = !{!"isBindless", i1 false}
!159 = !{!"simplePushLoads"}
!160 = !{!"simplePushInfoArrVec[1]", !152, !153, !154, !155, !156, !157, !158, !159}
!161 = !{!"simplePushInfoArrVec[2]", !152, !153, !154, !155, !156, !157, !158, !159}
!162 = !{!"simplePushInfoArrVec[3]", !152, !153, !154, !155, !156, !157, !158, !159}
!163 = !{!"simplePushBufferUsed", i32 0}
!164 = !{!"pushAnalysisWIInfos"}
!165 = !{!"inlineRTGlobalPtrOffset", i32 0}
!166 = !{!"rtSyncSurfPtrOffset", i32 0}
!167 = !{!"psInfo", !168, !169, !170, !171, !172, !173, !174, !175, !176, !177, !178, !179, !180, !181, !182}
!168 = !{!"BlendStateDisabledMask", i8 0}
!169 = !{!"SkipSrc0Alpha", i1 false}
!170 = !{!"DualSourceBlendingDisabled", i1 false}
!171 = !{!"ForceEnableSimd32", i1 false}
!172 = !{!"outputDepth", i1 false}
!173 = !{!"outputStencil", i1 false}
!174 = !{!"outputMask", i1 false}
!175 = !{!"blendToFillEnabled", i1 false}
!176 = !{!"forceEarlyZ", i1 false}
!177 = !{!"hasVersionedLoop", i1 false}
!178 = !{!"forceSingleSourceRTWAfterDualSourceRTW", i1 false}
!179 = !{!"NumSamples", i8 0}
!180 = !{!"blendOptimizationMode"}
!181 = !{!"colorOutputMask"}
!182 = !{!"WaDisableVRS", i1 false}
!183 = !{!"csInfo", !184, !185, !186, !187, !188, !30, !31, !189, !190, !191, !192, !193, !59, !194}
!184 = !{!"maxWorkGroupSize", i32 0}
!185 = !{!"waveSize", i32 0}
!186 = !{!"ComputeShaderSecondCompile"}
!187 = !{!"forcedSIMDSize", i8 0}
!188 = !{!"forceTotalGRFNum", i32 0}
!189 = !{!"forcedVISAPreRAScheduler", i1 false}
!190 = !{!"disableLocalIdOrderOptimizations", i1 false}
!191 = !{!"disableDispatchAlongY", i1 false}
!192 = !{!"neededThreadIdLayout", i1* null}
!193 = !{!"forceTileYWalk", i1 false}
!194 = !{!"ResForHfPacking"}
!195 = !{!"msInfo", !196, !197, !198, !199, !200, !201, !202, !203, !204}
!196 = !{!"PrimitiveTopology", i32 3}
!197 = !{!"MaxNumOfPrimitives", i32 0}
!198 = !{!"MaxNumOfVertices", i32 0}
!199 = !{!"MaxNumOfPerPrimitiveOutputs", i32 0}
!200 = !{!"MaxNumOfPerVertexOutputs", i32 0}
!201 = !{!"WorkGroupSize", i32 0}
!202 = !{!"WorkGroupMemorySizeInBytes", i32 0}
!203 = !{!"IndexFormat", i32 6}
!204 = !{!"SubgroupSize", i32 0}
!205 = !{!"taskInfo", !206, !201, !202, !204}
!206 = !{!"MaxNumOfOutputs", i32 0}
!207 = !{!"NBarrierCnt", i32 0}
!208 = !{!"rtInfo", !209, !210, !211, !212, !213, !214, !215, !216, !217, !218}
!209 = !{!"RayQueryAllocSizeInBytes", i32 0}
!210 = !{!"NumContinuations", i32 -1}
!211 = !{!"RTAsyncStackAddrspace", i32 -1}
!212 = !{!"RTAsyncStackSurfaceStateOffset", i1* null}
!213 = !{!"SWHotZoneAddrspace", i32 -1}
!214 = !{!"SWHotZoneSurfaceStateOffset", i1* null}
!215 = !{!"SWStackAddrspace", i32 -1}
!216 = !{!"SWStackSurfaceStateOffset", i1* null}
!217 = !{!"RTSyncStackAddrspace", i32 -1}
!218 = !{!"RTSyncStackSurfaceStateOffset", i1* null}
!219 = !{!"CurUniqueIndirectIdx", i32 0}
!220 = !{!"inlineDynTextures"}
!221 = !{!"inlineResInfoData"}
!222 = !{!"immConstant", !223, !224}
!223 = !{!"data"}
!224 = !{!"sizes"}
!225 = !{!"inlineConstantBuffers"}
!226 = !{!"inlineGlobalBuffers"}
!227 = !{!"GlobalPointerProgramBinaryInfos"}
!228 = !{!"ConstantPointerProgramBinaryInfos"}
!229 = !{!"GlobalBufferAddressRelocInfo"}
!230 = !{!"ConstantBufferAddressRelocInfo"}
!231 = !{!"forceLscCacheList"}
!232 = !{!"SrvMap"}
!233 = !{!"RasterizerOrderedByteAddressBuffer"}
!234 = !{!"MinNOSPushConstantSize", i32 0}
!235 = !{!"inlineProgramScopeOffsets"}
!236 = !{!"shaderData", !237}
!237 = !{!"numReplicas", i32 0}
!238 = !{!"URBInfo", !239, !240, !241}
!239 = !{!"has64BVertexHeaderInput", i1 false}
!240 = !{!"has64BVertexHeaderOutput", i1 false}
!241 = !{!"hasVertexHeader", i1 true}
!242 = !{!"UseBindlessImage", i1 false}
!243 = !{!"enableRangeReduce", i1 false}
!244 = !{!"allowMatchMadOptimizationforVS", i1 false}
!245 = !{!"disableMemOptforNegativeOffsetLoads", i1 false}
!246 = !{!"statefulResourcesNotAliased", i1 false}
!247 = !{!"disableMixMode", i1 false}
!248 = !{!"PrivateMemoryPerFG"}
!249 = !{!"capabilities", !250}
!250 = !{!"globalVariableDecorationsINTEL", i1 false}
!251 = !{!"m_ShaderResourceViewMcsMask", !252, !253}
!252 = !{!"m_ShaderResourceViewMcsMaskVec[0]", i64 0}
!253 = !{!"m_ShaderResourceViewMcsMaskVec[1]", i64 0}
!254 = !{!"computedDepthMode", i32 0}
!255 = !{!"isHDCFastClearShader", i1 false}
!256 = !{i32 3, i32 0}
!257 = !{}
!258 = !{!"-cl-std=CL3.0"}
